.386
.model flat,stdcall
option casemap:none

include Sockets.inc

.code

start:

	invoke GetModuleHandle,NULL
	mov    hInstance,eax
	invoke GetCommandLine
	invoke InitCommonControls
	mov		CommandLine,eax
	invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL	wc:WNDCLASSEX
	LOCAL	msg:MSG

	mov		wc.cbSize,sizeof WNDCLASSEX
	mov		wc.style,CS_HREDRAW or CS_VREDRAW
	mov		wc.lpfnWndProc,offset WndProc
	mov		wc.cbClsExtra,NULL
	mov		wc.cbWndExtra,DLGWINDOWEXTRA
	push	hInst
	pop		wc.hInstance
	mov		wc.hbrBackground,COLOR_BTNFACE+1
	mov		wc.lpszMenuName, NULL
	mov		wc.lpszClassName,offset ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov		wc.hIcon,eax
	mov		wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov		wc.hCursor,eax
	invoke RegisterClassEx,addr wc
	invoke CreateDialogParam,hInstance,IDD_DIALOG,NULL,addr WndProc,NULL
	invoke ShowWindow,hWnd,SW_SHOWNORMAL
	invoke UpdateWindow,hWnd
	.while TRUE
		invoke GetMessage,addr msg,NULL,0,0
	  .BREAK .if !eax
		invoke TranslateMessage,addr msg
		invoke DispatchMessage,addr msg
	.endw
	mov		eax,msg.wParam
	ret

WinMain endp

WndProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		push	hWin
		pop		hWnd
		
		; Get the handles for my windows widgets
		invoke	GetDlgItem, hWnd, IDC_SOC
		mov		hSocButton, eax
		invoke	GetDlgItem, hWnd, IDC_CON
		mov		hConsole, eax
		
	.elseif eax==WM_COMMAND
		mov		eax,wParam
		and		eax,0FFFFh
		.if eax==IDC_SOC
			
			;----< snip >------------;
			; Before the program starts, we need to setup the WinSock.Dll, open a port
			; and configure the port.
			
			;---------------------------;		
			; Initalise the WinSock.dll ;
			;---------------------------;
			invoke	WSAStartup, 101h, addr wsadata
			.if eax!=NULL
				invoke	MessageBox, hWnd, addr sWinSockErr, addr AppName, MB_OK
			.else 
				invoke	SendMessage, hConsole, WM_SETTEXT, 0, addr sWinSockOk
			.endif
			
			;----------------;
			; open a socket. ;
			;----------------;
			invoke	socket, PF_INET, SOCK_STREAM, 0 
			.if eax!=INVALID_SOCKET
				mov		hSock, eax			; socket set ok. 
				invoke	SendMessage, hConsole, WM_SETTEXT, 0, addr sSockOk
			.else
				invoke	MessageBox, hWnd, addr sSockErr, addr AppName, MB_OK
			.endif
			
			;-------------------------------------------------------------------------------------------;
			; Setup the socket options. By default, windows defaults to port blocking. I make this call :
			; to set the port to non-blocking                                                           ;
			;-------------------------------------------------------------------------------------------;
			invoke	WSAAsyncSelect, hSock, hWnd, WM_SOCKET, FD_CONNECT+FD_READ+FD_CLOSE
			.if eax==SOCKET_ERROR
				invoke	MessageBox, hWnd, addr sSetErr, addr AppName, MB_OK
			.else
				invoke	SendMessage, hConsole, WM_SETTEXT, 0, addr sSetOk
			.endif
			
			; set my socket up with port information. 
			
			mov		sin.sin_family, AF_INET					; set my protocol
			invoke	htons, 3333								; define my port number
			mov		sin.sin_port, ax
			invoke	gethostbyname, addr ServerIPAddress		; get hostname by IP address
			mov		eax, [eax+12]
			mov		eax, [eax]
			mov		eax, [eax]
			mov		sin.sin_addr, eax
			
			
			
			invoke	connect, hSock, addr sin, sizeof sin
			;invoke	listen, hSock, 1						; listen out for connections
			.if eax==SOCKET_ERROR
				
				invoke	MessageBox, hWnd, addr sListenErr, addr AppName, MB_OK
			.else	
				invoke	SendMessage, hWnd, WM_SETTEXT, 0, addr sListenOk
			.endif
			
			invoke	send, hSock, addr SendBuffer, sizeof SendBuffer, 0 
			
			
		.endif
		
		; -----< snip >-----; 
;	.elseif eax==WM_SIZE
	.elseif eax==WM_SOCKET							; we have socket activity...
		mov		eax, lParam							; low word of lParam contains the event code
		.if	ax==FD_CONNECT
			; we have connection 
		.endif	
	.elseif eax==WM_CLOSE
		invoke DestroyWindow,hWin
	.elseif uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
	.else
		invoke DefWindowProc,hWin,uMsg,wParam,lParam
		ret
	.endif
	xor    eax,eax
	ret

WndProc endp

end start
